variables:
  PIPELINE_NAME: "Checking for new tags" 

workflow:
  name: '$PIPELINE_NAME'
  rules:
    - if: '$CI_PIPELINE_SOURCE == "web"'
      variables:
        PIPELINE_NAME: 'Deployment Pipeline'
    - when: always  # Other pipelines can run, but use the default name


include:
- versions.yml

stages:
- build
- dev
- staging
- production


project-a:dev:
  stage: dev
  variables:
    ENVIRONMENT: dev
    VERSION: $PROJECT_A_VERSION
  trigger:
    project: regrabneffop-ultimate/experiments/orchestrated/project-a
    branch: $PROJECT_A_VERSION
    strategy: depend
    forward:
      pipeline_variables: true
      yaml_variables: true
  rules:
  - if: '$CI_PIPELINE_SOURCE == "web" && $PROJECT_A_VERSION != "none"'
  - when: never
  environment:
    name: "dev/project-a"
  

project-b:dev:
  stage: dev
  variables:
    ENVIRONMENT: dev
    VERSION: $PROJECT_B_VERSION
  trigger:
    project: regrabneffop-ultimate/experiments/orchestrated/project-b
    branch: $PROJECT_B_VERSION
    strategy: depend
    forward:
      pipeline_variables: true
      yaml_variables: true
  rules:
  - if: '$CI_PIPELINE_SOURCE == "web" && $PROJECT_B_VERSION != "none"'
  - when: never
  environment:
    name: "dev/project-b"
    


project-a:staging:
  stage: staging
  variables:
    ENVIRONMENT: staging
    VERSION: $PROJECT_A_VERSION
    STAGING: staging
  trigger:
    project: regrabneffop-ultimate/experiments/orchestrated/project-a
    branch: $PROJECT_A_VERSION
    strategy: depend
    forward:
      pipeline_variables: true
      yaml_variables: true
  rules:
  - if: '$CI_PIPELINE_SOURCE == "web" && $PROJECT_A_VERSION != "none"'
  - when: never
  needs:
  - "project-a:dev"
  environment:
    name: "staging/project-a"
  

project-b:staging:
  stage: staging
  variables:
    ENVIRONMENT: staging
    VERSION: $PROJECT_B_VERSION
  trigger:
    project: regrabneffop-ultimate/experiments/orchestrated/project-b
    branch: $PROJECT_B_VERSION
    strategy: depend
    forward:
      pipeline_variables: true
  rules:
  - if: '$CI_PIPELINE_SOURCE == "web" && $PROJECT_B_VERSION != "none"'
  - when: never
  needs:
  - "project-b:dev"
  environment:
    name: "staging/project-b"


reconcile-versions:
  stage: build
  image: python:slim
  script:
  - pip install -r requirements.txt > /dev/null
  - python aggregate.py
  - cat versions.yml
  rules:
  - if: '$CI_PIPELINE_SOURCE == "web"'
    when: never
  - when: always

